BrainstormSessions/ViewModels/IdeaViewModel.cs
using System;

namespace BrainstormSessions.ViewModels
{
    public class IdeaViewModel
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public string Description { get; set; }
        public DateTimeOffset DateCreated { get; set; }
    }
}

BrainstormSessions/ViewModels/StormSessionViewModel.cs
using System;

namespace BrainstormSessions.ViewModels
{
    public class StormSessionViewModel
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public DateTimeOffset DateCreated { get; set; }
        public int IdeaCount { get; set; }
    }
}

BrainstormSessions/Controllers/HomeController.cs
using System;
using System.ComponentModel.DataAnnotations;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Threading.Tasks;
using BrainstormSessions.Core.Interfaces;
using BrainstormSessions.Core.Model;
using BrainstormSessions.ViewModels;
using log4net;
using log4net.Config;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using Serilog;

namespace BrainstormSessions.Controllers
{
    public class HomeController : Controller
    {
        private readonly IBrainstormSessionRepository _sessionRepository;
        private readonly ILog _logger;
        public HomeController(IBrainstormSessionRepository sessionRepository)
        {
            _sessionRepository = sessionRepository;
            _logger = LogManager.GetLogger(MethodBase.GetCurrentMethod().DeclaringType);
        }

        public async Task<IActionResult> Index()
        {
            _logger.Info("Index execution start (Log4net)");
            Log.Logger.Information("Index execution start (Serilog)");

            var sessionList = await _sessionRepository.ListAsync();

            var model = sessionList.Select(session => new StormSessionViewModel()
            {
                Id = session.Id,
                DateCreated = session.DateCreated,
                Name = session.Name,
                IdeaCount = session.Ideas.Count
            });

            return View(model);
        }

        public class NewSessionModel
        {
            [Required]
            public string SessionName { get; set; }
        }

        [HttpPost]
        public async Task<IActionResult> Index(NewSessionModel model)
        {
            _logger.Info("Index execution start (Log4net)");
            Log.Logger.Information("Index execution start (Serilog)", model);

            if (!ModelState.IsValid)
            {
                _logger.Warn("ModelState of session is invalid (Log4net)");
                Log.Logger.Warning("ModelState of session is invalid (Serilog)", model);
                return BadRequest(ModelState);
            }
            else
            {
                await _sessionRepository.AddAsync(new BrainstormSession()
                {
                    DateCreated = DateTimeOffset.Now,
                    Name = model.SessionName
                });
            }

            return RedirectToAction(actionName: nameof(Index));
        }
    }
}

BrainstormSessions/Controllers/SessionController.cs
using System.Reflection;
using System.Threading.Tasks;
using BrainstormSessions.Core.Interfaces;
using BrainstormSessions.ViewModels;
using log4net;
using Microsoft.AspNetCore.Mvc;
using Serilog;

namespace BrainstormSessions.Controllers
{
    public class SessionController : Controller
    {
        private readonly IBrainstormSessionRepository _sessionRepository;
        private readonly ILog _logger;
        public SessionController(IBrainstormSessionRepository sessionRepository)
        {
            _sessionRepository = sessionRepository;
            _logger = LogManager.GetLogger(MethodBase.GetCurrentMethod().DeclaringType);
        }

        public async Task<IActionResult> Index(int? id)
        {
            _logger.Info("Index execution start (Log4net)");
            Log.Logger.Information("Index execution start (Serilog)");

            if (!id.HasValue)
            {
                _logger.Error("Id hasn't value (Log4net)");
                Log.Logger.Error("Id hasn't value (Serilog)", id);
                return RedirectToAction(actionName: nameof(Index),
                    controllerName: "Home");
            }

            _logger.Debug($"Session search start with id {id} (Log4net)");
            Log.Logger.Debug($"Session search start with id {id} (Serilog)");

            var session = await _sessionRepository.GetByIdAsync(id.Value);
            if (session == null)
            {
                _logger.Warn("Session not found (Log4net)");
                Log.Logger.Warning("Session not found (Serilog)");
                return Content("Session not found.");
            }

            var viewModel = new StormSessionViewModel()
            {
                DateCreated = session.DateCreated,
                Name = session.Name,
                Id = session.Id
            };

            _logger.Debug($"Returning session view model {viewModel.Name} (Log4net)");
            Log.Logger.Debug($"Returning session view model {viewModel.Name} (Serilog)", viewModel);

            return View(viewModel);
        }
    }
}

BrainstormSessions/Views/Home/Index.cshtml
@model IEnumerable<BrainstormSessions.ViewModels.StormSessionViewModel>

@{
    ViewBag.Title = "Brainstormer";
    Layout = "_Layout";
}

<h2>Brainstorm Sessions</h2>
<div class="row">
    <div class="col-md-9">
        @foreach (var storm in Model)
        {
            <div class="panel panel-default">
                <div class="panel-heading">
                    <a href="@Url.Action("Index","Session", new {id=@storm.Id})">@storm.Name</a> - @storm.DateCreated.ToString()
                </div>
                <div class="panel-body">
                    @storm.IdeaCount ideas
                </div>
            </div>
        }
    </div>
    <div class="col-md-3">
        <div class="panel panel-primary">
            <div class="panel-heading">
                Add New Session
            </div>
            <div class="panel-body">
                <form method="post" asp-controller="Home" asp-action="Index">
                    <fieldset class="form-group">
                        <label for="sessionName">New Session Name</label>
                        <input type="text" class="form-control" id="sessionName" name="SessionName" placeholder="Name" required />
                    </fieldset>
                    <input type="submit" value="Save" id="SaveButton" name="SaveButton" class="btn btn-primary" />
                </form>
            </div>
        </div>
    </div>
</div>

BrainstormSessions/Views/Session/Index.cshtml
@model BrainstormSessions.ViewModels.StormSessionViewModel

@{
    ViewBag.Title = "Brainstormer Session : " + Model.Name;
    Layout = "_Layout";
}
<h2>Brainstorm Session: @Model.Name</h2>
<div class="small">@Model.DateCreated</div>

<div class="row">
    <div class="col-md-9">
        <h3>Idea Count: <span data-bind="text:ideas().length"></span></h3>
        <div data-bind='foreach: ideas'>
            <div class="panel panel-default">
                <div class="panel-heading" data-bind="text:name">
                </div>
                <div class="panel-body" data-bind="text:description">
                </div>
            </div>
        </div>
    </div>
    <div class="col-md-3">
        <div class="panel panel-primary">
            <div class="panel-heading">
                Add New Idea
            </div>
            <div class="panel-body">
                <div data-bind="with: ideaForEditing">
                    <fieldset class="form-group">
                        <label for="ideaName">Idea Name</label>
                        <input type="text" class="form-control" id="ideaName" name="ideaName" placeholder="New Idea" data-bind="value:name">
                    </fieldset>
                    <fieldset class="form-group">
                        <label for="ideaDescription">Description</label>
                        <textarea class="form-control" id="ideaDescription" name="ideaDescription" data-bind="value:description"></textarea>
                    </fieldset>
                    <input type="submit" value="Save" id="SaveButton" name="SaveButton" class="btn btn-primary" data-bind="click: $root.addIdea">
                </div>
            </div>
        </div>
    </div>
</div>
<div class="row">
    <div class="col-md-12">
        <a href="/">Return home</a>
    </div>
</div>
@section Scripts {
    <script type="text/javascript">
        var Idea = function(id, name, description) {
            this.id = ko.observable(id);
            this.name = ko.observable(name);
            this.description = ko.observable(description);
            this.sessionId = @Model.Id;
        };
        var ViewModel = function() {
            var self = this;
            self.ideas = ko.observableArray([]);
            self.ideaForEditing = ko.observable(new Idea());
            self.addIdea = function(newIdea) {
                if(newIdea.name() != undefined && newIdea.description() != undefined)
                {
                    console.log("add idea: " + newIdea.name() + " desc: " + newIdea.description());
                    self.ideas.push(newIdea);
                    $.ajax({
                        url: '/api/ideas/create',
                        type: 'POST',
                        data: ko.toJSON(newIdea),
                        contentType: 'application/json'
                    });
                    self.ideaForEditing(new Idea());
                }
            }
        };
        viewModel = new ViewModel();
        ko.applyBindings(viewModel);
        $(function() {
            $.ajax({
                url: '/api/ideas/forsession/@Model.Id',
                dataType: 'json',
                success: function(data) {
                    if (data instanceof Array) {
                        viewModel.ideas(data);
                    }
                }
            });
        });
    </script>
}

BrainstormSessions/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta name="viewport" content="width=device-width">
    <title>@ViewBag.Title</title>
    <environment include="Development">
        <link rel="stylesheet" href="/css/bootstrap.css">
    </environment>
    <environment exclude="Development">
        <link rel="stylesheet" href="https://ajax.aspnetcdn.com/ajax/bootstrap/3.3.7/css/bootstrap.min.css" asp-fallback-href="/css/bootstrap.css" asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute">
    </environment>
</head>
<body>
<div class="container">
    @RenderBody()
</div>
<environment include="Development">
    <script src="/js/jquery-2.2.0.js"></script>
    <script src="/js/bootstrap.js"></script>
    <script src="/js/knockout-3.4.2.js"></script>
    <script src="/js/knockout.mapping.js"></script>
</environment>
<environment exclude="Development">
    <script src="https://ajax.aspnetcdn.com/ajax/jQuery/jquery-2.2.0.min.js" asp-fallback-src="/js/jquery-2.2.0.js" asp-fallback-test="window.jQuery"></script>
    <script src="https://ajax.aspnetcdn.com/ajax/bootstrap/3.3.7/bootstrap.min.js" asp-fallback-src="/js/bootstrap.js" asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal"></script>
    <script src="https://ajax.aspnetcdn.com/ajax/knockout/knockout-3.4.2.js" asp-fallback-src="/js/knockout-3.4.2.js" asp-fallback-test="window.ko"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/knockout.mapping/2.4.1/knockout.mapping.min.js" asp-fallback-src="/js/knockout.mapping.js" asp-fallback-test="window.ko.mapping"></script>
</environment>
@RenderSection("Scripts", false)
</body>
</html>